:: 1. Install PostgreSQL to your machine 
:: 2. FILL OUT FOLLOWING VARIABLES:
  
	:: Database name
	SET DatabaseName=DB_test
	:: Machine name
	SET MachineName=autotex5
	:: Port, default 5432
	SET Port=5432
	:: Texture directory, will be created; choose drive with enough space and read/write permissions
	SET TexturesPath=\\%MachineName%\Daten\Texturen\%DatabaseName%
	:: psql directory (PostgreSQL software installation\bin)
	SET BinDir="c:\Program Files\PostgreSQL\15\bin"
	:: Tablespace dir, will be created, use double "\\" !!
	SET TblSpc=F:\\_DATENBANKEN\\PostgreSQL\\tablespaces
	:: Database superuser "postgres" password
	SET PostgresPW=nlIAdmDB_21
	:: CityGRID user
	SET CGUser=cityman
	:: CityGRID user password
	SET CGPW=city
	:: Current directory (with subdir SQL, no need to change it)
	SET Dir=%CD%
	
:: 3. DONT CHANGE ANYTHING MORE
:: 4. Run this bat
	
:: **************************************************************************************
	:: Creating directories
		MD %TexturesPath%
		MD %DatabaseName%\log
		MD %TblSpc%
		
	:: Copying SQL files
		COPY "%Dir%\SQL\PROC_DEL_TEXTURE_CITYDB__3_0.sql" "%Dir%\%DatabaseName%\PROC_DEL_TEXTURE_CITYDB__3_0.sql"
		COPY "%Dir%\SQL\procedures.sql" "%Dir%\%DatabaseName%\procedures.sql"
		COPY "%Dir%\SQL\schema.sql" "%Dir%\%DatabaseName%\schema.sql"
		COPY "%Dir%\SQL\views.sql" "%Dir%\%DatabaseName%\views.sql"
		
		
	:: Copying CreateCGDB.sql with replacing strings: %CGUser%, %CGPW%, %DatabaseName%, %TblSpc%
		DEL "%Dir%\%DatabaseName%\CreateCGDB.sql"
		SETLOCAL EnableDelayedExpansion
		For /f "tokens=* delims= " %%a in (%Dir%\SQL\CreateCGDB_template.sql) do (
			Set str=%%a
			set str=!str:--CGUser--=%CGUser%!
			set str=!str:--CGPW--=%CGPW%!
			set str=!str:--DatabaseName--=%DatabaseName%!
			set str=!str:--TblSpc--=%TblSpc%!
			echo !str!>>"%Dir%\%DatabaseName%\CreateCGDB.sql"
		)
		ENDLOCAL
		
	:: Copying Defaults.sql with replacing strings: %TexturesPath%
		DEL "%Dir%\%DatabaseName%\Defaults.sql"
		SETLOCAL EnableDelayedExpansion
		For /f "tokens=* delims= " %%a in (%Dir%\SQL\Defaults_template.sql) do (
			Set str=%%a
			set str=!str:--TexturesPath--=%TexturesPath%!
			echo !str!>>"%Dir%\%DatabaseName%\Defaults.sql"
		)
		ENDLOCAL
	
	:: CD to psql directory

		CD /d %BinDir%
	
	:: PGPASSWORD must be set as global variable before connecting to DB server
		set PGPASSWORD=%PostgresPW%
	:: CREATE CGDB
		psql --username=postgres  --file="%Dir%\%DatabaseName%\CreateCGDB.sql"
	
	:: PGPASSWORD must be set as global variable before connecting to DB server
		set PGPASSWORD=%CGPW%
	:: CREATE Schema
		psql --dbname=%DatabaseName% --username=cityman  --file="%Dir%\%DatabaseName%\schema.sql"
		psql --dbname=%DatabaseName% --username=cityman  --file="%Dir%\%DatabaseName%\procedures.sql"
		psql --dbname=%DatabaseName% --username=cityman  --file="%Dir%\%DatabaseName%\views.sql"
		psql --dbname=%DatabaseName% --username=cityman  --file="%Dir%\%DatabaseName%\PROC_DEL_TEXTURE_CITYDB__3_0.sql"
		psql --dbname=%DatabaseName% --username=cityman  --file="%Dir%\%DatabaseName%\Defaults.sql"
	
	:: CD back to %Dir%

		CD /d %Dir%
		
	:: CGDB initialization
		"%CGUser%agerCMD64.exe" "checkDBSchemaVersion" 		"Driver={PostgreSQL ODBC Driver(UNICODE)};Server=%MachineName%;Port=%Port%;Database=%DatabaseName%;UID=%CGUser%;PWD=%CGPW%;Persist Security Info=True;Default Schema=%CGUser%;" "%CGUser%" "%Dir%\%DatabaseName%\log\InitCGDB.log" "FALSE"
		"%CGUser%agerCMD64.exe" "updateDBSchema" 			"Driver={PostgreSQL ODBC Driver(UNICODE)};Server=%MachineName%;Port=%Port%;Database=%DatabaseName%;UID=%CGUser%;PWD=%CGPW%;Persist Security Info=True;Default Schema=%CGUser%;" "%CGUser%" "%Dir%\%DatabaseName%\log\InitCGDB.log" "FALSE"
		"%CGUser%agerCMD64.exe" "checkDBSchemaVersion" 		"Driver={PostgreSQL ODBC Driver(UNICODE)};Server=%MachineName%;Port=%Port%;Database=%DatabaseName%;UID=%CGUser%;PWD=%CGPW%;Persist Security Info=True;Default Schema=%CGUser%;" "%CGUser%" "%Dir%\%DatabaseName%\log\InitCGDB.log" "FALSE"
		"%CGUser%agerCMD64.exe" "checkDBSchemaVersion" 		"Driver={PostgreSQL ODBC Driver(UNICODE)};Server=%MachineName%;Port=%Port%;Database=%DatabaseName%;UID=%CGUser%;PWD=%CGPW%;Persist Security Info=True;Default Schema=%CGUser%;" "%CGUser%" "%Dir%\%DatabaseName%\log\InitCGDB.log" "FALSE"
		"%CGUser%agerCMD64.exe" "createMaterializedViews" 	"Driver={PostgreSQL ODBC Driver(UNICODE)};Server=%MachineName%;Port=%Port%;Database=%DatabaseName%;UID=%CGUser%;PWD=%CGPW%;Persist Security Info=True;Default Schema=%CGUser%;" "%CGUser%" "%Dir%\%DatabaseName%\log\InitCGDB.log" "FALSE"


