-- Prozedur/Funktion PROC_DEL_ELEMENT_GEOMETRY erstellen.
create or replace procedure proc_del_element_geometry 
	(in pelement numeric)
language plpgsql	
as $$
declare
	e record;
begin -- main
	delete from face where element = pelement; 
	delete from extrusion where element = pelement; 
	for e in select edgeline from edgeline where element = pelement loop 
		delete from edgeto where edgeline = e.edgeline; 
		delete from edgelineconnect where master = e.edgeline or slave = e.edgeline; 
	end loop; 
	delete from edgeline where element = pelement; 
	delete from userdef_edgetype where element = pelement; 
	delete from vertex where element = pelement; 
end;$$;

-- Prozedur/Funktion PROC_DEL_ELEMENT_TEXTURE erstellen.
create or replace procedure proc_del_element_texture 
	(pelement in numeric)
	language plpgsql
	as $$  
begin -- main
	declare
		exist numeric;
		e record;
		c record;
	
	begin
		for e in select texture from texture where element = pelement	loop
			update face set texture = null where texture = e.texture;
			for c in select color from texture where texture=e.texture loop
				update texture set color=null where color=c.color;
				delete from color where color=c.color;
			end loop;
		end loop;
		delete from texture where element = pelement;
		delete from texcoord where element = pelement;
    end;
end;$$;

-- Prozedur/Funktion PROC_DEL_ELEMENT erstellen.
create or replace  procedure proc_del_element 
	(pelement in numeric) 
	language plpgsql
	as $$ 
begin -- main
	call proc_del_element_geometry(pelement); 
	call proc_del_element_texture(pelement); 
	update element set lowerlod = null where lowerlod = pelement; 
	delete from element where element = pelement; 
end;$$;

-- Prozedur/Funktion PROC_DEL_ELEMENTCOMPLEX erstellen.
create or replace  procedure proc_del_elementcomplex 
	(pelementcomplex in numeric)
	language plpgsql
	as $$
 declare 
 e record;
begin -- main
	for e in select element from element where elementcomplex = pelementcomplex loop 
		call proc_del_element(e.element); 
	end loop; 
	delete from elementcomplex where elementcomplex=pelementcomplex; 
end;$$;

-- Prozedur/Funktion PROC_DEL_OBJECT erstellen.
create or replace procedure proc_del_object 
	(pobject in numeric) 
	language plpgsql
	as $$
 declare
 e record;
begin -- main
	update elementcomplex set parent=null where (object = pobject); 
	for e in select elementcomplex from elementcomplex where object = pobject loop 
		call proc_del_elementcomplex(e.elementcomplex); 
	end loop; 
	delete from object where object=pobject; 
end;$$;

-- Prozedur/Funktion PROC_DEL_UNIT erstellen.
create or replace procedure proc_del_unit 
	(punit in numeric)
	language plpgsql
	as $$
 declare
 obj record; 
begin -- main
	for obj in select object from object where unit = punit loop 
		call proc_del_object(obj.object); 
	end loop; 
	delete from unitversion where unit = punit; 
	delete from modelunit where unit = punit; 
	delete from unit where unit = punit; 
end;$$;

-- Prozedur/Funktion PROC_DEL_UNITVERSION erstellen.
create or replace procedure proc_del_unitversion 
	(punitversion in numeric)
	language plpgsql
	as $$
 declare 
 obj record;
begin -- main
	for obj in select object from object where unitversion = punitversion  loop 
		call proc_del_object(obj.object); 
	end loop; 
	delete from unitversion where unitversion.unitversion = punitversion; 
end;$$;

-- Prozedur/Funktion PROC_DEL_MODEL erstellen.
create or replace procedure proc_del_model
	(pmodel in numeric)
	language plpgsql
	as $$ 
begin -- main
	delete from modelunit where model = pmodel; 
	delete from modelimage where model = pmodel; 
	delete from modelarea where model = pmodel; 
	delete from model where model = pmodel; 
end;$$;
