-- neue tabelle vertex erstellen.
-- vertex : table of vertex  
create table vertex (
	vertex bigint generated always as identity(start with 1 increment by 1) not null,
	world_long numeric(11,3) default 0 not null,
	world_lat numeric(11,3) default 0 not null,
	world_elev numeric(11,3) default 0 not null,
	element bigint not null, constraint vertex_pk primary key (vertex) ); 
	
-- neue tabelle unitversion erstellen.
-- unitversion : table of unitversion  	
create table unitversion (																						
	unitversion bigint generated always as identity(start with 1 increment by 1) not null,
	versionnumber numeric(12,0) default 0 not null,
	versiondate date not null,
	unit bigint not null,
	state numeric(2,0) not null,
	comment varchar(256) default 'created' null, constraint unitversion_pk primary key (unitversion) );

-- Neue Tabelle IMAGEVERSION erstellen.	
create table imageversion (
	imageversion bigint generated always as identity(start with 1 increment by 1) not null,
	versionnumber numeric(12,0) default 0 not null,
	versiondate date not null,
	"comment" varchar(256) default 'created' null,
	constraint imageversion_pk primary key (imageversion) ); 

-- Neue Tabelle AREAVERSION erstellen.
create table areaversion (
	areaversion bigint generated always as identity(start with 1 increment by 1) not null,
	versionnumber numeric(12,0) default 0 not null,
	versiondate date not null,
	"comment" varchar(256) default 'created' null,
	state numeric(2,0) default 1 not null,
	constraint areaversion_pk primary key (areaversion) ); 

	
-- neue tabelle unitgis erstellen.
-- unitgis : table of unitgis  
create table unitgis (
	giskey varchar(64) not null,
	unit bigint not null,
	street_number_int numeric(10,0) null);	
	
-- neue tabelle unitexport erstellen.
-- unitexport : table of unitexport  
create table unitexport (
	lod numeric(2,0) not null,
	type numeric(2,0) not null,
	exportdata bigint not null,
	unit bigint not null); 
	
-- neue tabelle unit erstellen.
-- unit : table of unit  
create table unit (
	unit bigint generated always as identity(start with 1 increment by 1) not null,
	world_long numeric(11,3) not null,
	world_lat numeric(11,3) not null,
	world_elev numeric(11,3) not null,
	unit_number numeric(9,0) null,
	namen varchar(255) null,
	web_description text null,
	web_link varchar(255) null,
	builtuparea numeric(11,3) not null, 
	bin_builtuparea bytea not null, 
	licstate varchar(6) not null, 
	bin_licstate bytea not null, 
	unitid varchar(255) not null, constraint pk_unit2 primary key (unit) ); 
	
-- neue tabelle texture erstellen.
-- texture : table of texture  
create table texture (
	texture bigint generated always as identity(start with 1 increment by 1) not null,
	image bigint null,
	color bigint null,
	transparency numeric(4,3) default 0 not null,
	def numeric(1,0) null,
	element bigint not null, constraint texture_pk primary key (texture) ); 
	
	
-- Neue Tabelle TEXCOORD erstellen.
-- TEXCOORD : Table of TEXCOORD  
create table texcoord (
	texcoord bigint generated always as identity(start with 1 increment by 1) not null,
	element bigint not null,
	x numeric(15,7) not null,
	y numeric(15,7) not null, constraint pk_texcoord62 primary key (texcoord) ); 

-- Neue Tabelle OBJECTCLASS erstellen.
-- OBJECTCLASS : Table of OBJECTCLASS  	
create table objectclass (
	objectclass numeric(3,0) not null,
	description varchar(255) null, constraint pk_objectclass4 primary key (objectclass) ); 

-- Neue Tabelle OBJECT erstellen.
-- OBJECT : Table of OBJECT  	
create table object (
	object int generated always as identity(start with 1 increment by 1) not null,
	unit bigint not null,
	objectclass numeric(3,0) not null,
	world_long numeric(11,3) default 0 not null,
	world_lat numeric(11,3) default 0 not null,
	world_elev numeric(11,3) default 0 not null,
	unitversion bigint not null,
	objectid varchar(256) null, constraint object_pk primary key (object) ); 
	
-- Neue Tabelle ELEMENTCOMPLEX erstellen.
create table elementcomplex (
	elementcomplex bigint generated always as identity(start with 1 increment by 1) not null,
	object int not null,
	parent bigint null,
	complexclass varchar(256) null,
	elev_lod_block numeric(11,3) null,
	depth_under_terrain numeric(11,3) default 0 not null,
	boundary bytea null,
	boundary_size numeric(5,0) null,
	constraint elementcomplex_pk primary key (elementcomplex),
	constraint object_fk foreign key (object) references object(object) ); 

-- Neue Tabelle MODELUNIT erstellen.
-- MODELUNIT : Table of MODELUNIT
-- 	ELEV_SHIFT : derives from elevation difference between master area and model area (generalization)  	
create table modelunit (
	model int not null,
	elev_shift numeric(8,3) null,
	unit bigint not null); 

-- Neue Tabelle MODEL erstellen.
-- MODEL : Table of MODEL  	
create table model (
	model int generated always as identity(start with 1 increment by 1) not null,
	namen varchar(255) null,
	constraint model_pk primary key (model) ); 
	
-- Neue Tabelle LOD erstellen.
-- LOD : Table of LOD
create table lod (
	lod numeric(2,0) not null,
	name varchar(255) null, constraint lod_pk primary key (lod) ); 
	
-- Neue Tabelle INTERIORORIENTATION erstellen.
-- INTERIORORIENTATION : Table of INTERIORORIENTATION  
create table interiororientation (
	interiororientation bigint generated always as identity(start with 1 increment by 1) not null,
	focal_length numeric(10,5) not null,
	irp_x numeric(10,5) not null,
	irp_y numeric(10,5) not null,
	camera varchar(256) null,
	calibration_date date null, constraint interiororientation_pk primary key (interiororientation) ); 

-- Neue Tabelle mit Installationsinfos + Lizenz (wird nur eine einzige Zeile haben) erstellen
create table inst_info (
	schema_version numeric(2,1) not null,
	license_key bytea,
	app_key_cookie bytea,
	texture_path varchar(260) not null,
	guid varchar(36) null,
	bin_guid bytea null,
	builtup_area_lod1 bytea null,
	builtup_area_lod2 bytea null,
	builtup_area_lod3 bytea null,
	builtup_area_tex bytea null);
	
-- Neue Tabelle PENDING_ACTIONS erstellen
create table pending_actions (
	title numeric(8,0) not null,
	message numeric(8,0) not null,
	msg_box_buttons numeric(2,0) not null );

-- Neue Tabelle UNIT_OCTREE erstellen.
create table unit_octree (
	page numeric(12,0) not null,
	lev numeric(12,0) not null,
	parent bigint not null,
	usedspace numeric(12,0) not null,
	branches bytea not null,
	constraint unit_tree_page_unique unique(page) );

	
-- Neue Tabelle IMGPYRAMIDLEVEL erstellen.
-- IMGPYRAMIDLEVEL : Table of IMGPYRAMIDLEVEL
create table imgpyramidlevel (
	resolution numeric(9,0) not null, constraint pk_imgpyramidlevel primary key (resolution) ); 

-- Neue Tabelle IMGPYRAMID erstellen.
-- IMGPYRAMID : Table of IMGPYRAMID  	
create table imgpyramid (
	dim_x numeric(6,0) not null,
	dim_y numeric(6,0) not null,
	content bytea null,
	resolution numeric(9,0) null,
	image bigint not null); 
	
-- Neue Tabelle IMGORIENTATIONCONNECT erstellen.
-- IMGORIENTATIONCONNECT : Table of IMGORIENTATIONCONNECT 
create table imgorientationconnect (
	imgorientationconnect bigint generated always as identity(start with 1 increment by 1) not null,
	imgorientation bigint not null,
	exteriororientation bigint not null,
	interiororientation bigint null,
	affinetrafo bigint not null, constraint imgorientationconnect_pk primary key (imgorientationconnect) ); 

-- Neue Tabelle IMGORIENTATION erstellen.
-- IMGORIENTATION : Table of IMGORIENTATION  
create table imgorientation (
	image bigint not null,
	imgorientation bigint generated always as identity(start with 1 increment by 1) not null,
	projtype numeric(2,0) default 0 not null,
	scanoffset_x numeric(11,3) null,
	scanoffset_y numeric(11,3) null,
	subimageoffset_x numeric(11,3) null,
	subimageoffset_y numeric(11,3) null,
	ortho_centreoffset_x numeric(11,3) null,
	ortho_centreoffset_y numeric(11,3) null,
	ortho_pixelsize numeric(9,0) null, constraint imgorientation_pk primary key (imgorientation) );
	
-- Neue Tabelle IMAGE erstellen.
-- IMAGE : Table of IMAGE  
create table image (
	image bigint generated always as identity(start with 1 increment by 1) not null,
	resolution numeric(9,0) not null,
	type numeric(2,0) not null,
	description text null,
	namen varchar(256) null,
	preview bytea null,
	reference varchar(256) null,
	imageversion bigint not null, 
	near_plane_dist numeric(12,3) null, 
	far_plane_dist numeric(12,3) null, 
	valid_photo_width numeric(12,3) null, 
	valid_photo_height numeric(12,3) null, 
	texture_creator numeric(2,0) null, 
	constraint image_pk primary key (image) ); 

-- neue tabelle face erstellen.
-- face : table of face  
create table face (
	face bigint generated always as identity(start with 1 increment by 1) not null,
	vertex1 numeric(9,0) null,
	vertex2 numeric(9,0) null,
	vertex3 numeric(9,0) null,
	element bigint not null,
	texture bigint null,
	texcoord1 numeric(9,0) null,
	texcoord2 numeric(9,0) null,
	texcoord3 numeric(9,0) null, constraint face_pk primary key (face) ); 

-- neue tabelle extrusion erstellen.
-- extrusion : table of extrusion
-- 	extrusion_type : a= extrude to area
-- 	p= extrude to parent element  
create table extrusion (
	dir_long numeric(5,4) not null,
	dir_lat numeric(5,4) not null,
	dir_elev numeric(5,4) not null,
	extrusion_type char(1) not null,
	element bigint not null, constraint pk_extrusion1 primary key (element) ); 

-- neue tabelle exteriororientation erstellen.
-- exteriororientation : table of exteriororientation  
create table exteriororientation (
	exteriororientation bigint generated always as identity(start with 1 increment by 1) not null,
	erp_x numeric(11,3) not null,
	erp_y numeric(11,3) not null,
	erp_z numeric(11,3) not null,
	angle_type numeric(2,0) not null,
	prim_angle numeric(10,7) not null,
	sec_angle numeric(10,7) not null,
	tert_angle numeric(10,7) not null, constraint exteriororientation_pk primary key (exteriororientation) );

-- neue tabelle exportdata erstellen.
-- exportdata : table of exportdata  
create table exportdata (
	exportdata bigint generated always as identity(start with 1 increment by 1) not null,
	data text not null, constraint exportdata_pk primary key (exportdata) ); 


-- neue tabelle elementclass erstellen.
-- elementclass : table of elementclass  
create table elementclass (
	elementclass numeric(3,0) not null,
	description varchar(255) null, constraint pk_elementclass3 primary key (elementclass) ); 

-- neue tabelle element erstellen.
-- element : table of element
-- 	"action" : 0=extend parent  1=replace parent
-- 	type : 1=polygon  2=surface  3=extrusion  
create table element (
	element bigint generated always as identity(start with 1 increment by 1) not null,
	elementcomplex bigint not null,
	type numeric(4,0) not null,
	elementclass numeric(3,0) not null,
	lod numeric(2,0) not null, 
	lowerlod bigint null, constraint pk_element primary key (element) ); 

-- neue tabelle edgeto erstellen.
-- edgeto : table of edgeto  
create table edgeto (
	edgeline bigint not null,
	ordering numeric(4,0) not null,
	vertex bigint not null); 

-- neue tabelle edgeline erstellen.
-- edgeline : table of edgeline
-- 	type : 0=structure (normale dachlinien)  1=contour (traufe außen)  2=cutout (traufe innen) 3=footprint (from extrusion)
-- 	code : 100=traufe  200=first  300=dach
-- 	500=grundriss  
create table edgeline (
	edgeline bigint generated always as identity(start with 1 increment by 1) not null,
	type numeric(4,0) null,
	vertex bigint not null,
	element bigint not null, constraint edgeline_pk primary key (edgeline) ); 
	
-- Neue Tabelle USERDEF_EDGETYPE erstellen.
create table userdef_edgetype (
	type numeric(4,0) not null,
	element bigint not null,
	name varchar(256) not null,
	constraint type_element_unique unique(type,element) ); 

-- Neue Tabelle EDGELINECONNECT erstellen.
create table edgelineconnect (
	master bigint not null,
	slave bigint not null,
	constraint edgelineconnect_master_fk foreign key (master) references edgeline(edgeline),
	constraint edgelineconnect_slave_fk foreign key (slave) references edgeline(edgeline) ); 

-- neue tabelle street_template erstellen.
-- street_template : table of street_template  
create table street_template (
	street_key varchar(16) not null,
	name varchar(256) not null); 

-- neue tabelle address_template erstellen.
-- address_template : table of address_template  
create table address_template (
	object_id varchar(16) not null,
	street_key varchar(16) null,
	street_number varchar(10) null,
	adr_x numeric(11,3) null,
	adr_y numeric(11,3) null,
	obj_x numeric(11,3) not null,
	obj_y numeric(11,3) not null); 

-- neue tabelle breakpoint erstellen.
-- breakpoint : table of breakpoint  
create table breakpoint (
	breakpoint bigint generated always as identity(start with 1 increment by 1) not null,
	world_lat numeric(11,3) not null,
	world_long numeric(11,3) not null,
	world_elev numeric(11,3) not null,
	area int null, constraint breakpoint_pk primary key (breakpoint) ); 

-- neue tabelle breakline erstellen.
-- breakline : table of breakline  
create table breakline (
	breakline bigint generated always as identity(start with 1 increment by 1) not null,
	breakpoint_start numeric(12,0) null,
	breakpoint_end numeric(12,0) null,
	area int null, constraint breakline_pk primary key (breakline) ); 

-- neue tabelle areaexport erstellen.
-- areaexport : table of areaexport  
create table areaexport (
	area int not null,
	type numeric(2,0) not null,
	exportdata numeric(12,0) not null); 

-- neue tabelle area erstellen.
-- area : table of area  
create table area (
	area int generated always as identity(start with 1 increment by 1) not null,
	ref_long numeric(11,3) null,
	ref_lat numeric(11,3) null,
	delta_long numeric(11,3) null,
	delta_lat numeric(11,3) null,
	dim_long numeric(11,0) null,
	dim_lat numeric(11,0) null,
	dtm_pointcount numeric(11,0) null,
	dtm_trianglecount numeric(11,0) null,
	parent bigint null,
	elevationgrid bytea null,
	dtm_points bytea null,
	dtm_texturecoordinates bytea null,
	dtm_triangles bytea null,
	namen varchar(255) null,
	areaversion bigint not null,
	bbox_minx numeric(12,3) not null,
	bbox_miny numeric(12,3) not null,
	bbox_minz numeric(12,3) not null,
	bbox_maxx numeric(12,3) not null,
	bbox_maxy numeric(12,3) not null,
	bbox_maxz numeric(12,3) not null,
	constraint area_pk primary key (area) ); 

-- Neue Tabelle MODELAREA erstellen.	
create table modelarea (
	model int not null,
	area int not null,
	constraint modelarea_model_fk foreign key (model) references model(model),
	constraint modelarea_area_fk foreign key (area) references area(area) ); 

-- Neue Tabelle MODELIMAGE erstellen.	
create table modelimage (
	model int not null,
	image bigint not null,
	type numeric(2,0) not null,
	constraint modelimage_model_fk foreign key (model) references model(model),
	constraint modelimage_image_fk foreign key (image) references image(image) ); 

-- neue tabelle affinetrafo erstellen.
create table affinetrafo (
	affinetrafo bigint generated always as identity(start with 1 increment by 1) not null,
	a0 numeric(16,8) not null,
	b0 numeric(16,8) not null,
	c0 numeric(16,8) not null,
	a1 numeric(16,8) not null,
	b1 numeric(16,8) not null,
	c1 numeric(16,8) not null, constraint affinetrafo_pk primary key (affinetrafo) ); 

-- neue tabelle color erstellen.
create table color (
	color bigint generated always as identity(start with 1 increment by 1) not null,
	red numeric(8,7) default 0 not null,
	green numeric(8,7) default 0 not null,
	blue numeric(8,7) default 0 not null,
	constraint color_pk primary key (color) );

-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle vertex hinzufügen.
create index ix_vertex_element on vertex (
	element asc); 


-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle unitversion hinzufügen.
create index ix_unitversion_unit on unitversion (
	unit asc); 


create unique index ix_unitversion_versionnumber on unitversion (
	unit,
	versionnumber); 


alter table unitversion add constraint ix_unitversion_vnumber_uc1 unique (
	unit,
	versionnumber); 


-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle unitexport hinzufügen.
create unique index ix_unitexport_unit on unitexport (
	unit asc,
	lod asc); 


-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle texture hinzufügen.
create index ix_texture_element on texture (
	element asc); 


-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle texcoord hinzufügen.
create index ix_texcoord_element on texcoord (
	element asc); 


-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle object hinzufügen.
create index ix_object_unit on object (
	unit asc); 


create index ix_object_unitversion on object (
	unitversion asc); 


-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle elementcomplex hinzufügen.
create index ix_elementcomplex_object on elementcomplex(
	object asc); 

create index ix_elementcomplex_parent on elementcomplex(
	parent asc); 

-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle modelunit hinzufügen.
create index ix_modelunit_model on modelunit (
	model asc); 


create index ix_modelunit_unit on modelunit (
	unit asc); 


-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle inst_info_unique hinzufügen.
alter table inst_info add constraint inst_info_unique unique (
	schema_version);

-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle face hinzufügen.
create index face_element_fk on face (
	element asc); 

create index face_texture on face (
	texture asc); 

-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle elementclass hinzufügen.
alter table elementclass add constraint tc_elementclass25 unique (
	description); 


-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle area hinzufügen.
create unique index ix_area_areaversion on area(area,areaversion);

-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle image hinzufügen.
create unique index ix_image_imageversion on image(image,imageversion);

-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle imgorientation hinzufügen.
create index ix_imgorientation_image on imgorientation(image);

-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle imgorientationconnect hinzufügen.
create index ix_imgoriconnect_imgori on imgorientationconnect(imgorientation);

-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle modelarea hinzufügen.
create index ix_modelarea_model on modelarea (model asc);
create index ix_modelarea_area on modelarea (area asc);

-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle modelimage hinzufügen.
create index ix_modelimage_model on modelimage (model asc);
create index ix_modelimage_image on modelimage (image asc);

-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle element hinzufügen.
create index ix_element_lod on element (
	elementcomplex asc,
	lod asc); 

create index ix_element_elementcomplex on element (
	elementcomplex asc); 

create index ix_element_lowerlod on element (
	lowerlod asc); 

-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle edgeto hinzufügen.
create unique index ix_edgeto_edgeline on edgeto (
	edgeline asc,
	ordering asc); 


-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle edgeline hinzufügen.
create index ix_edgeline_element on edgeline (
	element asc); 

-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle userdef_edgetype hinzufügen.
create index userdef_edgetype_element on userdef_edgetype (
	element asc); 

-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle strasse hinzufügen.
alter table street_template add constraint street_uc1 unique (
	street_key); 


-- verbleibende schlüssel, abhängigkeiten und indizes für tabelle breakline hinzufügen.
create index breakline_area_fk on breakline (
	area asc); 


-- fremdschlüsselabhängigkeiten zu tabelle vertex hinzufügen.
alter table vertex
	add constraint fk_vertex_element foreign key (
		element)
	 references element (
		element); 

-- fremdschlüsselabhängigkeiten zu tabelle unitversion hinzufügen.
alter table unitversion
	add constraint unit_unitversion_fk1 foreign key (
		unit)
	 references unit (
		unit); 

-- fremdschlüsselabhängigkeiten zu tabelle unitexport hinzufügen.
alter table unitexport
	add constraint fk_unitexport_lod foreign key (
		lod)
	 references lod (
		lod) on delete cascade; 

alter table unitexport
	add constraint fk_unitexport_unit foreign key (
		unit)
	 references unit (
		unit) on delete cascade; 

alter table unitexport
	add constraint fk_unitexport8 foreign key (
		exportdata)
	 references exportdata (
		exportdata) on delete cascade; 

-- fremdschlüsselabhängigkeiten zu tabelle texture hinzufügen.
alter table texture
	add constraint image_texture_fk1 foreign key (
		"image")
	 references "image" (
		"image"); 

alter table texture 
	add constraint fk_texture_color foreign key (
		color) 
	references color (
		color);

alter table texture
	add constraint texture_element_fk foreign key (
		element)
	 references element (
		element); 

-- fremdschlüsselabhängigkeiten zu tabelle texcoord hinzufügen.
alter table texcoord
	add constraint fk_texcoord9 foreign key (
		element)
	 references element (
		element); 

-- fremdschlüsselabhängigkeiten zu tabelle object hinzufügen.
alter table object
	add constraint fk_object_unit foreign key (
		unit)
	 references unit (
		unit); 

alter table object
	add constraint objectclass_object_fk1 foreign key (
		objectclass)
	 references objectclass (
		objectclass); 

alter table object
	add constraint unitversion_object_fk1 foreign key (
		unitversion)
	 references unitversion (
		unitversion); 

-- fremdschlüsselabhängigkeiten zu tabelle elementcomplex hinzufügen.
alter table elementcomplex
	add constraint parent_element_fk foreign key (
		parent)
		 references element (
		element); 

-- fremdschlüsselabhängigkeiten zu tabelle modelunit hinzufügen.
alter table modelunit
	add constraint fk_modelunit_model foreign key (
		model)
	 references model (
		model) on delete cascade; 

alter table modelunit
	add constraint fk_modelunit_unit foreign key (
		unit)
	 references unit (
		unit) on delete cascade; 

-- fremdschlüsselabhängigkeiten zu tabelle imgpyramid hinzufügen.
alter table imgpyramid
	add constraint fk_imagepyramid_image foreign key (
		"image")
	 references "image" (
		"image") on delete cascade; 

-- fremdschlüsselabhängigkeiten zu tabelle imgorientationconnect hinzufügen.
alter table imgorientationconnect
	add constraint fk_imgorconn_imgorientation foreign key (
		imgorientation)
	 references imgorientation (
		imgorientation) on delete cascade; 

alter table imgorientationconnect
	add constraint fk_imgorconn_extorientation foreign key (
		exteriororientation)
	 references exteriororientation (
		exteriororientation) on delete cascade; 

alter table imgorientationconnect
	add constraint fk_imgorconn_intorientation foreign key (
		interiororientation)
	 references interiororientation (
		interiororientation) on delete cascade; 

alter table imgorientationconnect
	add constraint fk_imgorconn_affinetrafo foreign key (
		affinetrafo)
	 references affinetrafo (
		affinetrafo) on delete cascade; 

-- fremdschlüsselabhängigkeiten zu tabelle imgorientation hinzufügen.
alter table imgorientation
	add constraint fk_orientation10 foreign key (
		"image")
	 references "image" (
		"image") on delete cascade; 

-- fremdschlüsselabhängigkeiten zu tabelle face hinzufügen.
alter table face
	add constraint face_element foreign key (
		element)
	 references element (
		element); 

alter table face
	add constraint face_texture_fk foreign key (
		texture)
	 references texture (
		texture); 

-- fremdschlüsselabhängigkeiten zu tabelle extrusion hinzufügen.
alter table extrusion
	add constraint extrsusion_element foreign key (
		element)
	 references element (
		element); 

-- fremdschlüsselabhängigkeiten zu tabelle element hinzufügen.
alter table element
	add constraint fk_element_elementcomplex foreign key (
		elementcomplex)
	 references elementcomplex (
		elementcomplex); 

alter table element 
	add constraint elementclass_element_fk1 foreign key (
		elementclass)
	 references elementclass(
	 	elementclass); 

alter table element 
	add constraint fk_element_lowerlod foreign key (
		lowerlod)
	 references element(
	 	element); 

-- fremdschlüsselabhängigkeiten zu tabelle edgeto hinzufügen.
alter table edgeto
	add constraint fk_edgeto_edgeline foreign key (
		edgeline)
	 references edgeline (
		edgeline); 

-- fremdschlüsselabhängigkeiten zu tabelle edgeline hinzufügen.
alter table edgeline
	add constraint fk_edgeline_element foreign key (
		element)
	 references element (
		element); 

-- fremdschlüsselabhängigkeiten zu tabelle userdef_edgetype hinzufügen.
alter table userdef_edgetype
	add constraint fk_userdef_edgetype_element foreign key (
		element)
	 references element (
		element); 

-- fremdschlüsselabhängigkeiten zu tabelle areaexport hinzufügen.
alter table areaexport
	add constraint area_areaexport foreign key (
		area)
	 references area (
		area) on delete cascade; 

-- fremdschlüsselabhängigkeiten zu tabelle area hinzufügen.
alter table area
	add constraint area_area foreign key (
		parent)
	 references area (
		area) on delete cascade; 

alter table area
	add constraint fk_area_areaversion foreign key (
		areaversion)
	 references areaversion (
		areaversion); 

-- fremdschlüsselabhängigkeiten zu tabelle image hinzufügen.
alter table image
	add constraint fk_image_imageversion foreign key (
		imageversion)
	 references imageversion (
		imageversion); 